<?php

session_write_close();

$functions = array();
global $functions;

require($installfolder.'/model/relationship.php');
require($installfolder.'/model/property.php');

class AQLPoint
{
	public $assetid = 0;
	public $sourceid = 0;
	public $dynamic = "";
	public $value = "";
	public $propertyid = 0;
	public $rawvalue = 0;
	public $fullvalue = "";
	public $type = "";
	public $name = "";
	public $history = FALSE;
	public $processed = FALSE;
}

class AQLStackElement
{
	public $islist = false;
	public $value = false;
	public $typename = "";
	public $name = "";
	
	function GetCode()
	{
		if ($this->typename == "const") 
		{
			//if ($this->islist == true)
			//	return "l";
			return "c";
		}
		if ($this->typename == "function") return "f";
		if ($this->typename == "command") return "x";
		if ($this->typename == "assetlist") return "a";
		if ($this->typename == "proplist") return "p";
		if ($this->typename == "pointlist") return "t";
		if ($this->typename == "rellist") return "r";
		if ($this->typename == "timeseries") return "s";
		if ($this->typename == "tabledata") return "d";
		if ($this->typename == "tablequery") return "q";
		if ($this->typename == "map") return "m";
		return "";
	}
}

class AQLFunction
{	
	public $stack = array();
	public $code = array();
	public $memory = array();
	public $prnt = False;
	
	public function ParseMapString($ms)
	{
		$ms = '{'.$ms.'}';
		//echo $ms;
		$map = json_decode($ms,TRUE);
		//print_r($map);
		//echo '<hr/>';
		return $map;
	}
	
	public function FromString($s)
	{
		$quotestack = array();
		$wd = "";
		$quoted = "";
		$style = "";
		for($x=0;$x<strlen($s);$x++)
		{
			$c = $s[$x];
			if ($c == ' ')
			{
				if ($quoted == "")
				{
					if (trim($wd) != "")
					{
						if (is_numeric($wd))
						{
							$style = 'const';
						}

						$ele = new AQLStackElement();
						$ele->typename = $style;						
						$ele->value = trim($wd);
						$this->code[] = $ele;
												
						$wd = "";
						$style = "command";
					}
				}
			}
			if ($quoted != "")
			{				
				if ($quoted == $c)
				{
					if ($quoted == ']')
					{
						$ele = new AQLStackElement();
						$ele->typename = "function";
						$ele->value = new AQLFunction();
						$ele->value->FromString($wd);
						$this->code[] = $ele;
					}
					else
					{
						if ($quoted == '}')
						{
							$ele = new AQLStackElement();
							$ele->typename = "map";
							$ele->value = $this->ParseMapString($wd);							
							$this->code[] = $ele;							
						}						
						else
						{
							if ($quoted == ')')
							{
								$ele = new AQLStackElement();
								$ele->typename = "const";						
								$ele->islist = true;
								$ele->value = str_getcsv($wd,',',"'");								
								$this->code[] = $ele;
								//print_r($ele);
							}
							else
							{
								if (is_numeric($wd))
								{
									$style = 'const';
								}

								$ele = new AQLStackElement();
								$ele->typename = $style;						
								$ele->value = trim($wd);
								$this->code[] = $ele;											
							}
						}
					}
					
					//array_pop($quotestack);
										
					$quoted = "";
					$wd = "";
					$style = "command";
					
					continue;
				}
				$wd = $wd.$c;
				continue;
			}
			
			if ($c == '\'')
			{
				$quoted = "'";
				$style = "const";
				continue;
			}
			if ($c == '[')
			{
				$quoted = ']';
				$style="function";
				continue;
			}
			
			if ($c == '(')
			{
				$quoted = ')';
				$style="list";
				continue;
			}
			
			if ($c == '{')
			{
				$quoted = '}';
				$style="map";
				continue;
			}
			$wd = $wd.$c;
		}
		if (trim($wd) != "")
		{
			if (is_numeric($wd))
			{
				$style = 'const';
			}

			$ele = new AQLStackElement();
			$ele->typename = $style;						
			$ele->value = trim($wd);
			$this->code[] = $ele;
		}			
		
		//print_r($this->code);
	}
	
	function Init()
	{
		
	}
	
	function GetShortcodes($min,$max)
	{
		$arr = array();
		$code = "";
		for($x=$min;$x<=$max;$x++)
		{
			if (isset($this->stack[$x]))
				$code .= $this->stack[$x]->GetCode();			
		}
		#echo "Checking For ".$code;
		return $code;
		
	}
	
	function Consume($n)
	{
		$lst = array();
		//echo '<br/>Parameter ';
		for($x=0;$x<$n;$x++)
		{
			//echo '<br/>'.$x.': ';
			$lst[] = array_pop($this->stack);
			//print_r($lst[count($lst)-1]);			
		}		
		
		return $lst;
	}
	
	function PrintStack()
	{
		echo '------<br/>';
		$pos = 0;
		foreach($this->stack as $s)
		{
			$pos = $pos + 1;
			echo $pos.': ';
			echo $s->typename.'<br/>';
			print_r($s->value);
			echo '<br/>';
		}
		echo '-------<br/>';
	}
	
	function ShortCodeVariants($code)
	{
		$variants = array();
		$variants[] = $code;
		$ln = strlen($code);
		//echo $code;
		for($x=0;$x<$ln;$x++)
		{
			$st = "";
			if ($x > 0) $st .= substr($code,0,$x);
			$st .= 'w';
			if ($x < $ln-1) $st .= substr($code,$x+1,$ln - $x);
			$variants[] = $st;
		}
		//print_r($variants);
		return $variants;
	}
	
	function RunCommand($cmd)
	{
		$max = count($this->stack);
		
		$mcode = "";
		$matched = false;
		$called = false;
		global $functions;		
		foreach($functions as $f)
		{			
			//echo trim($f).' / '.trim($cmd->value);
			if ($f == $cmd->value)
			{
				$matched = true;
				$tried = array();
				$hit = false;
								
				for($x=0;$x<=$max;$x++)
				{
					$codes = $this->GetShortcodes($x,$max);
					$variants = $this->ShortCodeVariants($codes);					
					if ($mcode == "") $mcode = $codes;
					foreach($variants as $v)
					{
						//echo 'Checking For '.$v;
						if (function_exists('fn_'.strtolower($cmd->value).'_'.$v))
						{
							$called = true;
							$mt = microtime(true);
							call_user_func('fn_'.strtolower($cmd->value).'_'.$v,$this);
							echo '<br/>Called <strong>'.$cmd->value.'</strong> (fn_'.strtolower($cmd->value).'_'.$codes.') in '.(microtime(true) - $mt).' seconds.<br/>';
							$this->PrintStack();
							$hit = true;
							break;
						}
					}
					if ($hit == true) break;
				}		
								
				if ($called == false)
				{
					echo 'Could not find a matching stack pattern for '.$cmd->value.' '.$mcode;
					$this->PrintStack();
				}
			}
		}
		
		if ($matched == false)
		{
			echo 'Could Not Find Matching Function &quot;'.$cmd->value."&quot;";
		}
		
	}
	
	public function ToList()
	{
		$lst = array();
		foreach($this->stack as $s)
		{
			$lst[] = $s;
		}
		
		return $lst;
	}
	
	public function Execute($initstack = true)
	{
		global $db;
		$db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$this->Init();
		if ($initstack == true) 
			$this->stack = [];
				
				
		//print_r($this->code);
		$expoint = -1;
		for($expoint=0;$expoint<count($this->code);$expoint++)
		{					
			$this->stack[] = $this->code[$expoint];
			$p = $this->stack[count($this->stack)-1];			
			
			if ($p->typename == "command")
			{				
				array_pop($this->stack);
				$this->RunCommand($p);
			}
			else
			{
				echo '<br/>Added Item to Stack ('.$p->typename.')<br/>';
				$this->PrintStack();
			}

			foreach($this->stack as $s)
			{
				if ($s->typename == "error")
				{
					echo "Exiting Due To Error: ".$s->value;					
					break;
				}
			}
		}
	}
	
}

class AQLQuery
{
	public $base = FALSE;
	#public $functions = array();
	
	public function Query($q)
	{
		global $installfolder;
		$this->base = new AQLFunction($this);
		
		global $functions;
		$files = glob($installfolder.'/addons/aql/api/functions/*.php');
		foreach($files as $f)
		{
			include_once($f);
			$functions[] = substr(strtoupper(pathinfo($f,PATHINFO_BASENAME)),0,-4);
		}		
		
		$original = $q;
		$macros = array();
		
		$files = glob($installfolder.'/addons/aql/api/functions/*.macro');
		foreach($files as $f)
		{
			$mac = file_get_contents($f);
			$lines = explode("\n",$mac);
			$macros[trim($lines[0])] = rtrim($lines[1]);
		}
		
		//echo '----'.$q.'----';
		
		foreach($macros as $k => $v)
		{
			//print($k);
			//echo '<br/>';
			$q = preg_replace($k,$v,$q);			
		}
		
		//echo '----'.$q.'----';
		
		$this->base->FromString($q);
		$this->base->Execute();
	}
}

#$qry = new AQLQuery();
//$qry->Query("'AG4-4C1' FINDASSET 'status' FINDPROP 'drive' REFINE 'mode' FINDPROP 'drive' REFINE MERGE RESOLVE");
//$qry->Query("'Flotation Tank C' FINDASSET INSIDE 'status' FINDPROP 'drive' REFINE RESOLVE");
#$qry->Query("'Flotation Tank C' FINDASSET 'location' FINDREL 'down' RELATED 'status' FINDPROP 'drive' REFINE RESOLVE MEDIAN");

function LiveValuesForPoints(&$points)
{
	$allprops = Properties::GetAllProperties();

	//Figure out more accurate mappings & live data bindings...
	$tofetch = array();
	
	//if ($points->showprocessed == true) continue;

	foreach($points as $p)
	{
		if ($p->propertyid != 0)
		{
			if ($p->processed === False)
			{
				$p->processed = true;				
				$ass = new Asset($p->assetid);
				$props = $ass->GetProperties(true,true);				
				foreach($props as $px)
				{
					if ($px->id == $p->propertyid)
					{						
						if ($px->origintype == "template")
						{
							$px->origin = $ass->id;
						}
						$prop = False;
						foreach($allprops as $pr)
						{
							if ($pr->id == $px->id)
							{
								$prop = $pr;
								break;
							}
						}
						
						$p->dynamic = $px->origin.':'.$p->propertyid.':';
						if ($prop->type == "MEASUREMENT") 
						{
							//$p->rawvalue = $px->value['measurement'];
							//$p->value = $px->value['measurement'].$px->value['units'];
							$p->dynamic .= "measurement";
						}
						if ($prop->type == "STATUS")
						{
							$p->dynamic .= "state";
							//$val = $px->value['state'];
							$val = $p->rawvalue;
							$p->rawvalue = $val;
							$map = $prop->GetValueMap();
							if (isset($map[$val]))
								$val = $map[$val];
							else
								$val = "Unknown";
							
							$p->value = $val;
						}
						if ($prop->type == "ENUM")
						{
							$p->dynamic .= "value";
							//$val = $px->value['value'];
							$val = $p->rawvalue;
							//$p->rawvalue = $val;
							//echo 'Value: '.$val;
							
							$map = $prop->GetValueMap();							
							if (isset($map[$val]))
								$val = $map[$val];
							else
								$val = "Unknown";
							
							$p->value = $val;
						}
						if ($prop->type == "LOOKUP")
						{
							$p->dynamic .= "value";
							$val = $px->value['value'];
							$p->rawvalue = $val;
							$map = $prop->GetValueMap();
							if (isset($map[$val]))
								$val = $map[$val];
							else
								$val = "Unknown";
							
							$p->value = $val;
						}
						$tofetch[] = $p->dynamic;
					}
				}
			}
		}
	}

	//Grab live data where appropriate
	
	$alist = array();
	$proplist = array();
	$dynamicdata = array();
	foreach($tofetch as $f)
	{
		$bits = explode(':',$f);
		
		if (!in_array($bits[0],$alist))
			$alist[] = $bits[0];
		if (!in_array($bits[1],$proplist))
			$proplist[] = $bits[1];
	}

	global $db;
	$sampleprofile = 1;

	#print_r($tofetch);
	if (count($alist) > 0)
	{
		$query = $db->query('SELECT node,assetid,propertyid FROM datalinks WHERE profile='.$sampleprofile.' AND assetid IN ('.implode(',',$alist).') AND propertyid IN ('.implode(',',$proplist).')');
		
		//print('SELECT node,assetid,propertyid FROM datalinks WHERE profile='.$sampleprofile.' AND assetid IN ('.implode(',',$alist).') AND propertyid IN ('.implode(',',$proplist).')');

		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$v = $row['assetid'].':'.$row['propertyid'].':'.$row['node'];			
			//print($v);
			if (in_array($v,$tofetch))
			{
				//echo 'Found '.$v;
				if (!in_array($v,$dynamicdata))
					$dynamicdata[] = $v;
			}
		}
	}

	//print_r($dynamicdata);

	$tm = microtime(true);

	$debug = false;
	
	//print_r($results);
	
	if (count($dynamicdata) > 0)
	{
		//echo 'Grabbing Live Data!';
		//print_r($dynamicdata);
				
				$codelookup = array();
				$indexlookup = array();
				
				$sampleprofile = 1;
				
				$dynset = implode(',',$dynamicdata);
					
				//Figure out the local consolidator port...
				$query = $db->query('SELECT reqport FROM profiles WHERE id='.$sampleprofile);

				while($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$conport = $row['reqport'];
				}
			
				$url = "http://localhost:".$conport."/snapshot";
				$ch = curl_init(); 
				//echo 'Calling '.$url.' / '.$dynset;
				curl_setopt($ch, CURLOPT_URL, $url); 
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS,  'codes='.urlencode($dynset));
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				$output = curl_exec($ch); 
				curl_close($ch);    
				
				//Process the XML results
				//echo $output;
				//echo urlencode($dynset);
				$xml=simplexml_load_string($output);
				
				//print_r($xml);
				if (isset($xml->points[0]))
				{
					foreach($xml->points[0]->point as $pv)
					{
						//Assign Values
						//print_r($pv);
						$code = strtolower($pv->attributes()['code']);
						
						foreach($points as $res)
						{							
							if($res->dynamic == $code)
							{								
								$res->value = $pv->attributes()['value'];
								$res->rawvalue = $pv->attributes()['value'];
							}
						}					
					}		
				}

		if ($debug == true)
		{
			echo ' '.(microtime(true) - $tm).' ]<br/>';
		}
	}

}
?>