<?php

$pagesize = 10;
$pagestart = 0;

$extension = $_REQUEST['id'];

$title = "ARDI Extension Install";

include($installfolder.'/include/tmpl.php');

function cmp($a, $b)
{
    if ($a == $b) {
        return 0;
    }
    return version_compare($b, $a);
}

$platform = "windows";

$info = file_get_contents("https://ardi.optrix.com.au/extensions/".$extension.'/info.json');
$inf = json_decode($info);

// Initialize a file URL to the variable 
$url = 'https://ardi.optrix.com.au/extensions/download.php?code='.$extension; 
  
// Use basename() function to return the base name of file  
@mkdir($sitefolder.'/install');
@mkdir($sitefolder.'/install/'.$extension);
$file_name = $sitefolder.'/install/'.$extension.'/download.zip'; 

 
$log = "";

$py = PythonPath();
$outp = array();
exec($py.' -V',$outp);
   
$pythonv = $outp[0];
$bits = explode('.',$pythonv);
$pversion = $bits[0].$bits[1];
   
if ($inf->type == 'driver')
{
	//Shut down drivers of this type...	
	//print($py);
	
	$cmd = '"'.$py.'" "'.dirname($installfolder).'\Drivers\ardidrivers.py" localhost* remove --driver='.$extension;
	$log .= "Shutting Down Existing Drivers via ".$cmd;
	exec($cmd);
}	


set_time_limit(0);
//This is the file where we save the information
$fp = fopen ($file_name, 'w+');
//Here is the file we are downloading, replace spaces with %20
$ch = curl_init(str_replace(" ","%20",$url));
curl_setopt($ch, CURLOPT_TIMEOUT, 50);
// write curl response to file
curl_setopt($ch, CURLOPT_FILE, $fp); 
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
// get curl response
curl_exec($ch); 
curl_close($ch);
fclose($fp);

$wheels = glob($sitefolder.'/install/'.$extension.'/*.whl');
foreach($wheels as $wheel)
{
	unlink($wheel);//$wheelset[] = $wheel;
}


$zip = new ZipArchive();
$log .= "Opening ZIP Archive ".$file_name."<br/>";
if($zip->open($file_name))
{
	$zip->extractTo($sitefolder.'/install/'.$extension);
	$zip->close();
}
else
{
	echo 'Not a ZIP Archive';
	exit;
}

//Investigate file - check for dodgy elements.
$log .= "Inspecting Archive Contents @ ".$sitefolder.'/install/'.$extension."<br/>";

$dodgy = false;
$pth = $sitefolder.'/install/'.$extension;
$content = glob($pth.'/*');
foreach($content as $cnt)
{
	$dodge = true;
	
	$base = basename($cnt);
	$log .= $base."<br/>";
	switch($base)
	{
		case 'download.zip':
		case 'download_dependencies.zip':
		case 'services':
		case 'drivers':		
		case 'web':
			$dodge = false;
			break;
	}
	
	if ($dodge == true)
	{
		$dodgy = true;
		$log .= "Encountered Unexpected File @ ".$cnt."<br/>";
		break;
	}
}

if (file_exists($pth.'/web'))
{
	$content = glob($pth.'/web/*');
	foreach($content as $cnt)
	{
		$dodge = true;
		
		$base = basename($cnt);
		$log .= $base."<br/>";
		switch($base)
		{
			case 'data':
			case 'addons':		
				$dodge = false;
				break;
		}
		
		if ($dodge == true)
		{
			$dodgy = true;
			$log .= "Encountered Unexpected File @ ".$cnt."<br/>";
			break;
		}
	}
}

if (file_exists($pth.'/web/data'))
{
	$content = glob($pth.'/web/data/*');
	foreach($content as $cnt)
	{
		$dodge = true;
		
		$base = basename($cnt);
		$log .= $base."<br/>";
		switch($base)
		{
			case 'live':
			case 'historical':		
			case 'event':		
				$dodge = false;
				break;
		}
		
		if ($dodge == true)
		{
			$dodgy = true;
			$log .= "Encountered Unexpected File @ ".$cnt."<br/>";
			break;
		}
	}
}

if (file_exists($pth.'/services'))
{
	$content = glob($pth.'/services/*');
	foreach($content as $cnt)
	{
		$dodge = true;
		
		$base = basename($cnt);
		$log .= $base."<br/>";
		switch($base)
		{			
			case 'consolidator':		
				$dodge = false;
				break;
		}
		
		if ($dodge == true)
		{
			$dodgy = true;
			$log .= "Encountered Unexpected File @ ".$cnt."<br/>";
			break;
		}
	}
}

if (file_exists($pth.'/drivers'))
{
	$content = glob($pth.'/drivers/*');
	foreach($content as $cnt)
	{
		$dodge = true;
		
		$base = basename($cnt);
		$log .= $base."<br/>";
		switch($base)
		{
			case 'live':
			case 'hist':		
			case 'event':		
				$dodge = false;
				break;
		}
		
		if ($dodge == true)
		{
			$dodgy = true;
			$log .= "Encountered Unexpected File @ ".$cnt."<br/>";
			break;
		}
	}
}

if ($dodgy == false)
{
	
	//OK - let's decompress this into the real location...
	if($zip->open($file_name))
	{
		$log .= "Extracting File to ".dirname($installfolder);
		$zip->extractTo(dirname($installfolder));
		$zip->close();
	}
	//unlink($file_name);
	
	$log .= "Checking for Python Scripts under ".dirname($installfolder).'<br/>';
	

	//Now, check for wheels....

	$failed = false;

	if (isset($inf->depends))
	{
		//Download the dependencies...
		
		$platform="win32";
		$pythonversion=$pversion;
		
		switch(strtoupper(PHP_OS))
		{
			case "WINNT":
			case "WIN32":
			case "WINDOWS":
				$platform="win32";
				break;
			default:
				$platform="linux";
				break;
		}
		
		//unlink($file_name);
		$file_name = $sitefolder.'/install/'.$extension.'/download_dependencies.zip'; 
		$url = 'https://ardi.optrix.com.au/extensions/wheels.php?code='.$extension.'&platform='.$platform.'&python='.$pythonversion; 
		$log .= "Downloading Dependencies from ".$url." to ".$sitefolder.'/install/'.$extension;		
		  		
		set_time_limit(0);
		//This is the file where we save the information
		$fp = fopen ($file_name, 'w+');
		//Here is the file we are downloading, replace spaces with %20
		$ch = curl_init(str_replace(" ","%20",$url));
		curl_setopt($ch, CURLOPT_TIMEOUT, 5000);
		// write curl response to file
		curl_setopt($ch, CURLOPT_FILE, $fp); 
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		// get curl response
		curl_exec($ch); 
		curl_close($ch);
		fclose($fp);
		
		if($zip->open($file_name))
		{
			$log .= "Extracting Wheels to ".$sitefolder.'/install/'.$extension;
			$zip->extractTo($sitefolder.'/install/'.$extension);
			$zip->close();
		}
		
		//Install python wheels for appropriate platform & Python version...
		$wheelset = array();
		$wheels = glob($sitefolder.'/install/'.$extension.'/*.whl');
		foreach($wheels as $wheel)
		{
			$wheelset[] = $wheel;
		}
		
		sort($wheelset);
		$packages = explode(';',$inf->depends);
		
		foreach($wheelset as $wheel)
		{		
			$bits = explode('-',basename($wheel));
			//$log .= 'Reviewing Wheel: Package '.$bits[0].', Version '.$bits[1].', version '.$bits[2].' / '.$bits[3].', platform '.$bits[4].'<br/>';
			if (in_array($bits[0],$packages))
			{
				$log .= 'Executing &quot;'.'pip install --no-index --find-links=. '.$wheel.'&quot;<br/>';
				
				$outp = array();
				$errs = array();
				exec('pip install --no-index --find-links=. '.$wheel,$outp,$errs);
				
				if (is_array($outp))
				{
					foreach($outp as $ln)
					{
						$log .= $ln."<br/>";
					}
				}
				if (is_array($errs))
				{
					foreach($errs as $ln)
					{
						$log .= '<p style="color: red;">'.$ln."</p>";
						if (trim($ln) != "")
							$failed = true;
					}
				}
			}
		}
	}
	
	if ($failed != true)
	{
		$tx = $inf->name."\r\n".$inf->version;
		file_put_contents($installfolder.'/pages/info/'.$inf->code.'.ver',$tx);
	}
}

if ($inf->type == 'driver')
{
	//Restart drivers of this type...
	$cmd = '"'.$py.'" '.$installfolder.'\Drivers\ardidrivers.py" localhost* install --driver='.$extension;
	$log .= "Restoring existing drivers via ".$cmd;
	exec($cmd);
}	

global $db;

T('header-basic','title='.$title);

$localversions = "";

ST('section','class=content');
	ST('row');
	
		ST('half');
			ST('box','title=Installation Log');				
				echo '<h2>'.$inf->name.' ('.$inf->version.')</h2>';
				echo '<p>'.$log.'</p>';
				echo '<br/>';
				echo '<a href="'.$siteroot.'/extender"><button class="btn btn-success">Back To Extension List</button></a>';
			ET();
		ET();
		
	ET();
ET();

?>
