import pymssql
import argparse
import datetime
import os
import traceback

port = 0
db = None        
host = ""
database = ""
username = ""
password = ""

pagelimit = 500
pageoffset = 0

addr = ""

search = os.getenv("search","")
framestart = os.getenv("framestart","")
frameend = os.getenv("frameend","")

framestart = os.getenv("mssql_after","")
frameend = os.getenv("mssql_before","")

parser = argparse.ArgumentParser(description='Get events from a MS SQL data source')
parser.add_argument('address', metavar='Address',
                   help='The name of the server')

args = parser.parse_args()
addr = args.address

#print addr
prefix = None
bits = addr.split(":")

tz = False
filter = ""

if len(bits) >= 6:
    host = bits[0]
    port = bits[1]
    database = bits[2]
    username = bits[3]
    password = bits[4]
    table = bits[5]
    name = bits[6]
    start = bits[7]
    end = bits[8]
    length = bits[9]
if len(bits) > 10:
    prefix = bits[10]
if len(bits) > 11:
    tz = bits[11]
if len(bits) > 12:
    filter = bits[12]

try:
    pagelimit = int(os.environ["MSSQL_PAGELIMIT"])
except:
    pass

try:
    pageoffset = int(os.environ["MSSQL_PAGEOFFSET"])
except:
    pass

db = pymssql.connect(host=host + ":" + port,user=username,password=password,database=database,login_timeout=10)

#print str(os.environ)

csr = db.cursor()
#timing = time.time()

#print "Search = " + search

active = start
if (active == ""):
    active = end

reqtotal = pagelimit + (pageoffset)

limits = "TOP(" + str(reqtotal)+ ") "

if pagelimit == -1:
    limits = ""

qry = "SELECT " + limits + name
if (start != ""):
    qry += ", " + start
if (end != ""):
    qry += ", "+end
if (length != ""):
    qry += ", "+length

whereit = False
qry += " FROM " + table + " "

#print qry

if search != "":
	if whereit == False:
		qry += "WHERE "
		whereit = True
	qry += name + " LIKE '%" + search + "%' OR " + name + "='" + search + "' "

if framestart != "":
	if start != "":
		if whereit == False:
			qry += "WHERE "
			whereit = True
		else:
		    qry += "AND "
		if frameend != "":
                    qry += start + " >= '" + framestart + "' AND " + start + " <= '" + frameend + "'"
                else:
                    qry += start + " <= '" + framestart
	else:
		if whereit == False:
			qry += "WHERE "
			whereit = True
		else:
		    qry += "AND "
		if frameend != "":
        	    qry += end + " >= '" + framestart + "' AND " + end + " <= '" + frameend + "'"
        	else:
                    qry += end + " <= '" + framestart + "'"

if filter != "":
    if (search == "") and (framestart == ""):
        qry += "WHERE "
    else:
        qry += " AND "
    qry += filter

qry += " ORDER BY "+active+" DESC";

#print qry
#print "Skipping " + str(pageoffset) + " items!"
#print "#Requesting " + qry
try:	
    csr.execute(qry)
    #print "Working"
    for row in csr:
        if pageoffset > 0:
            pageoffset = pageoffset - 1
            continue
        
        vv = ""
        if prefix is not None:
            vv += prefix
        vv += str(row[0]).strip()
        if (start != "") and (end != ""):
            vv += "\t" + str(row[1]).strip() + "\t" + str(row[2]).strip()
        if (start != "") and (end == "") and (length == ""):
            vv += "\t" + str(row[1]).strip() + "\t" + str(row[1]).strip()
        if (start != "") and (end == "") and (length != ""):
            vv += "\t" + str(row[1]).strip()
            dt = row[1]
            
            if type(dt) is datetime.datetime:
                dd = dt + datetime.timedelta(0,row[2])
            else:
                dd = datetime.datetime.strptime(dt,"%Y-%m-%d %H:%M:%S") + datetime.timedelta(0,row[2])
                
            vv += "\t" + str(dd).strip()
        if (start == "") and (end != "") and (length == ""):
            vv += "\t" + str(row[1]).strip() + "\t" + str(row[1]).strip()
            #print "Dodge."
        if (start == "") and (end != "") and (length != ""):
            #Calculate length...
            dt = row[1]
            if type(dt) is datetime.datetime:
                dd = dt + datetime.timedelta(0,-row[2])
            else:
                dd = datetime.datetime.strptime(dt,"%Y-%m-%d %H:%M:%S") + datetime.timedelta(0,-row[2])
            vv += "\t" + str(dd).strip()   
            vv += "\t" + str(row[1]).strip()
        print vv
except Exception as e:
    print str(e)
    traceback.print_exc()
    
db.commit()                     
csr.close()
db = None

#print "Done!"
