import pymssql
import argparse
import datetime
import os
import traceback

port = 0
db = None        
host = ""
database = ""
username = ""
password = ""

addr = ""

search = os.getenv("search","")
framestart = os.getenv("framestart","")
frameend = os.getenv("frameend","")

parser = argparse.ArgumentParser(description='Get events from a MS SQL data source')
parser.add_argument('address', metavar='Address',
                   help='The name of the server')

args = parser.parse_args()
addr = args.address

#print addr
prefix = None
bits = addr.split(":")

if len(bits) >= 6:
    host = bits[0]
    port = bits[1]
    database = bits[2]
    username = bits[3]
    password = bits[4]
    table = bits[5]
    name = bits[6]
    start = bits[7]
    end = bits[8]
    length = bits[9]
if len(bits) > 10:
    prefix = bits[10]

db = pymssql.connect(host=host + ":" + port,user=username,password=password,database=database,login_timeout=10)

csr = db.cursor()
#timing = time.time()

#print "Search = " + search

active = start
if (active == ""):
    active = end

qry = "SELECT TOP(20) " + name
if (start != ""):
    qry += ", " + start
if (end != ""):
    qry += ", "+end
if (length != ""):
    qry += ", "+length

whereit = False
qry += " FROM " + table + " "

#print qry

if search != "":
	if whereit == False:
		qry += "WHERE "
		whereit = True
	qry += name + " LIKE '%" + search + "%' OR " + name + "='" + search + "' "

if framestart != "":
	if start != "":
		if whereit == False:
			qry += "WHERE "
			whereit = True
		else:
		    qry += "AND "
		qry += start + " >= '" + framestart + "' AND " + start + " <= '" + frameend + "'"
	else:
		if whereit == False:
			qry += "WHERE "
			whereit = True
		else:
		    qry += "AND "
		qry += end + " >= '" + framestart + "' AND " + end + " <= '" + frameend + "'"

qry += " ORDER BY "+active+" DESC";

#print "#Requesting " + qry
try:	
    csr.execute(qry)
    #print "Working"
    for row in csr:
        vv = ""
        if prefix is not None:
            vv += prefix
        vv += str(row[0]).strip()
        if (start != "") and (end != ""):
            vv += "\t" + str(row[1]).strip() + "\t" + str(row[2]).strip()
        if (start != "") and (end == "") and (length == ""):
            vv += "\t" + str(row[1]).strip() + "\t" + str(row[1]).strip()
        if (start != "") and (end == "") and (length != ""):
            vv += "\t" + str(row[1]).strip()
            dt = row[1]
            
            if type(dt) is datetime.datetime:
                dd = dt + datetime.timedelta(0,row[2])
            else:
                dd = datetime.datetime.strptime(dt,"%Y-%m-%d %H:%M:%S") + datetime.timedelta(0,row[2])
                
            vv += "\t" + str(dd).strip()
        if (start == "") and (end != "") and (length == ""):
            vv += "\t" + str(row[1]).strip() + "\t" + str(row[1]).strip()
        if (start == "") and (end != "") and (length != ""):
            #Calculate length...
            dt = row[1]
            if type(dt) is datetime.datetime:
                dd = dt + datetime.timedelta(0,-row[2])
            else:
                dd = datetime.datetime.strptime(dt,"%Y-%m-%d %H:%M:%S") + datetime.timedelta(0,-row[2])
            vv += "\t" + str(dd).strip()   
            vv += "\t" + str(row[1]).strip()
        print vv
except Exception as e:
    print str(e)
    traceback.print_exc()
    
db.commit()                     
csr.close()
db = None

#print "Done!"