<?php

$bits = explode('>',$fetchaddress);

$frames = array();
$expression = $bits[0];
$parts = explode('|',$expression);
$lastend = 0;
foreach($parts as $p)
{
	$bits = explode('=',$p);
	$pieces = explode('-',$bits[0]);	
	$f = array();
	$f['start'] = strtotime($pieces[0]);
	$f['end'] = strtotime($pieces[1]);
	$f['name'] = $bits[1];
	
	if ($f['start'] < $lastend)
	{
		$f['start'] += 86400;
	}
	if ($f['end'] < $f['start'])
	{
		$f['end'] += 86400;
	}
		
	$frames[] = $f;
	
	$lastend = $f['end'];
}

function GetCurrentFrame($tm,$frames)
{
	$tx = new DateTime('@'.$tm);
	$ts = strtotime($tx->format('H').':'.$tx->format('m').':'.$tx->format('s'));
	foreach($frames as $f)
	{
		if (($ts >= $f['start']) && ($ts <= $f['end']))
		{
			return $f;
		}
	}
	
	return FALSE;
}

function GetPreviousFrame($f,$frames)
{
	for($x=0;$x<count($frames);$x++)
	{
		if ($frames[$x]['start'] == $f['start'])
		{
			if($x == 0)
				return $frames[count($frames)-1];
			else
				return $frames[$x-1];
		}
	}
	return FALSE;
}

date_default_timezone_set('Etc/UTC');

$sp = mktime(0,0,0);
if (!isset($pagelimit)) $pagelimit = 100;
if (!isset($pageoffset)) $pageoffset = 0;

//echo 'Offset: '.$pageoffset;

$items = 0;
$totalitems = $pagelimit;

//echo 'Starting...';

if ((isset($search)) && ($search != ""))
{
	if ($startframe != "")
	{
		$st = $startframe;
		$en = $endframe;
		
		$tm = $en;
		//echo $endframe;
		$gd = getdate($endframe);
		
		$sp = mktime(0,0,0,$gd['mon'],$gd['mday'],$gd['year']);
	
	}
	else
	{
		$st = $sp - (365*24*60*60);
		$tm = $sp;
	}

	$diff = ($sp-$tm) % $every;
	$sp = $tm - $diff;
		
	$any = false;
	
	while($items < $totalitems)
	{
		if ($pageoffset > 0)
		{
			$pageoffset--;
			$sp -= $every * 60;
			continue;
		}
		$nm = $prefix.date("H:i",$sp).' - '.date("H:i",$sp+($every*60)).' '.date("d/m/Y",$sp);
		
		if (strpos($nm,$search) != FALSE)
		{
			$any = true;
			$event = array();
			$event['name'] = $nm;
			$event['start'] = date("Y-m-d H:i:s",$sp);
			$event['end'] = date("Y-m-d H:i:s",$sp + ($every * 60));
			$eventset[] = $event;
			$items++;
		}
		else
		{
			if ($any == true) break;
		}
		$sp -= ($every * 60);
		if ($sp < 0) break;
	}
}
else
{
	$tm = time();
	$sp = mktime(0,0,0);
	$ep = 0;
	
	if (isset($before))
	{
		$sp = $before;
		//echo 'Using Before: '.$sp;
	}
	
	if (isset($after))
	{
		$ep = $after;
		//echo 'Using After: '.$ep;
	}	

	//echo 'Recent - Starting At '.date("H:i:s Y/m/d",$sp).' and working towards '.date("H:i:s Y/m/d",$tm);
	while($items < $totalitems)
	{
		if ($pageoffset > 0)
		{
			$pageoffset--;
			$sp -= $every * 60;		
			continue;
		}
		$event = array();
		$event['name'] = $prefix.date("H:i",$sp).' - '.date("H:i",$sp+($every*60)).' '.date("d/m/Y",$sp);
		$event['start'] = date("Y-m-d H:i:s",$sp);
		$event['end'] = date("Y-m-d H:i:s",$sp + ($every * 60));
		$eventset[] = $event;
		$items++;
		$sp -= $every * 60;	

		//print_r($sp);
		//print_r($ep);
		//echo '<br/><br/>';
		if ($sp < $ep) 
		{
			//echo 'Done!';
			break;
		}
	}
}

?>